/*****************************************************
CVAVR V2.05
Chip type               : ATtiny13A
AVR Core Clock frequency: 9,6 MHz
*****************************************************/
#include <tiny13a.h>

typedef unsigned char u8;
typedef unsigned int 	u16;
typedef unsigned long u32;

u16 tmr[3];
u8  ADC1=0xff;
u8  ADC2;
bit hven=0;




inline void t0_cfg()
{
 TCCR0A=1<<COM0A1|1<<COM0B1|1<<COM0B0|1<<WGM00;
 TCCR0B=1; OCR0A=0xff/2+1;OCR0B=0xff/2-1;  //phase correct pwm, top 0xff, no prsc
 TIMSK0|=1<<TOIE0;
}
inline void gpio_cfg()
{
  PORTB= 0b00000011;
 	DDRB = 0b00001011;
}
inline void adc_cfg()
{
 ADMUX  =1<<REFS0|1<<ADLAR|2;
 ADCSRA =1<<ADEN|1<<ADSC|5;
}

u8 bat_detect()
{
#define Vbn (u8)((1090UL*255)/1595)
#define Vbt (u8)((1200UL*255)/1595)
#define Vbl (u8)((950UL*255)/1595)
static bit trg=0;

 if(ADC1>Vbn){tmr[1]=0xffff;}
 else if((ADC1<Vbl)||(!tmr[1])){tmr[0]=0xffff;trg=1;}
 
 if((ADC1>Vbt)&&(!tmr[0])){trg=0;} 
 
  
 if((trg)||(tmr[0]))return 0;
 else return 1;
}

interrupt [TIM0_OVF] void t0_ovf_isr()
{
#define thw 188 
#define Ustv    ((200*0xff)/346) //147
#define HUmax   ((11UL*(470000UL+1500))/(1500*10)) //346
#define tps     (thw-thw/10)

 u8 i;
 static u8 tcs=0,b=tps,n;
 static u16 tmp2,tmp1;
 static bit trg;

 if(ADMUX&1){tmp1+=ADCH;n++;}else{tmp2+=ADCH;}
 
 if(tcs<thw-1){tcs++;}
 else
 {
    ADC1=tmp1/n;
    tmp1=0; n=0;
    ADC2=tmp2/b;//VHV 
    tmp2=0;tcs=0; 
    trg=0;
    if(hven)
    {
      if(ADC2>Ustv) {b=((u16)tps*Ustv)/ADC2;}
      else          {b=tps;}    
      TCCR0A=1<<COM0A1|1<<COM0B1|1<<COM0B0|1<<WGM00;
    }
    else {b=tps;TCCR0A=1;}
    ADMUX = 0xf2;//VHV
 }
 

 
 if(tcs<b){}
 else 
 {
    if(tcs>(b+((thw-b)>>1))){if(!trg){PORTB.3=~PORTB.3;trg=1;}}
    TCCR0A= 1;
    ADMUX = 0xf1;//Vbat    
 }

 
 ADCSRA |= 1<<ADSC;
 
 for(i=0;i<3;i++){if(tmr[i])tmr[i]--;} 

#asm("wdr");
}
void main(void)
{
gpio_cfg();
t0_cfg();
adc_cfg();



#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;

WDTCR=0x18;
WDTCR=0x08;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("sei");

while (1)
      {     
      if((!tmr[2])&&(bat_detect())){hven=1;}
      else{hven=0;}

      }
}


